/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _ABOUT_H_
#define _ABOUT_H_


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/window.h>
#include <gtkmm/eventbox.h>
#include <gtkmm/drawingarea.h>

class About : public Gtk::Window
{
public:
    static void show_dialog();

protected:
    About();
    ~About();  
  
    Gtk::EventBox m_EventBox;
    Gtk::DrawingArea m_DrawingArea;

    Glib::RefPtr < Gdk::Pixbuf > image;
    Glib::RefPtr < Gdk::Pixmap > pixmap;
    Glib::RefPtr < Pango::Layout > pangolayout;
    Glib::RefPtr < Gdk::GC > clip_gc;


    bool on_expose_event(GdkEventExpose * event);
    bool on_delete_event(GdkEventAny * event);

    bool update_text();
    bool on_drawable_clicked(GdkEventButton * data);

    bool is_running;
    int textpos;

    static About *the_dialog;

};


#endif //_ABOUT_H_
