/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _ARENADRAWINGAREA_H_
#define _ARENADRAWINGAREA_H_

#include <gtkmm/drawingarea.h>

#include "Vector2D.h"

class ArenaView;

class ArenaDrawingArea:public Gtk::DrawingArea {
  public:
    ArenaDrawingArea(ArenaView * parentp);
    ~ArenaDrawingArea();

    bool on_expose_event(GdkEventExpose *);
    void set_scale(double scale, int width, int height);
    void set_offset(double x, double y);

    void clear();

    void draw_line(double x1, double y1, double x2, double y2, double thickness, long color = 0x000000);
    void draw_lines(std::vector < Vector2D > points, double thickness, long color = 0x000000);
    void draw_circle(double x, double y, double radius, long color = 0x000000, const bool filled = true, double line_width = -1);
    void draw_arc(double x, double y, double radius, double angle1, double angle2, double line_width, long color = 0x000000);
    void draw_startupmessage(char *message);

  protected:
    ArenaView * parent;

    double scale;
    double x_offset, y_offset;

    double area_width, area_height;


    Gdk::Color make_gdk_color(const long col);
};

#endif				//_ARENADRAWINGAREA_H_
