/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _ARENAVIEW_H_
#define _ARENAVIEW_H_

#include <gtkmm/scrolledwindow.h>
#include <gtkmm/actiongroup.h>

#include <iostream>
using namespace std;

#include "Shapes.h"
#include "Robot.h"
#include "Arena.h"


class ArenaDrawingArea;


class ArenaView:public Gtk::ScrolledWindow {
  public:
    ArenaView();
    ~ArenaView();

    void draw_everything();
    void draw_shapes();
    void draw_robots();

    void update_scale();
    bool parse_turn();
    bool start(const char *name, TournamentType ttype);
    void pause();
    Glib::RefPtr < Gtk::ActionGroup > get_actions(){return m_refActionGroup;};

    
    double zoom;
    bool is_started;
    bool is_running;

  protected:
    bool startmessage;
    ArenaDrawingArea *DrawingArea;

    virtual void no_zoom();
    virtual void zoom_in();
    virtual void zoom_out();
    void update_actions();
  
    Glib::RefPtr < Gtk::ActionGroup > m_refActionGroup;
};


#endif				//_ARENAVIEW_H_
