/* 
 * RealTimeBattle Client
 * Copyright (C) 2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _COREINTERFACE_H_
#define _COREINTERFACE_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/dialog.h>
#include <gtkmm/entry.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/actiongroup.h>

#include "Stuff.h"

class CoreInterface
{
public:
    CoreInterface();
    ~CoreInterface();
    
    void connect();
    void disconnect();

    bool start_tournament(Glib::ustring& file);

    bool is_connected(){return connected;};
        
    int get_socket(){return socket;};
    Glib::RefPtr < Gtk::ActionGroup > get_actions();
    
protected:
    int socket;
    bool connected;

    Glib::RefPtr < Gtk::ActionGroup > m_refActionGroup;
    void update_actions();
    
    bool send_command(const char command, Glib::ustring& message);
};

extern CoreInterface the_iface;

class ConnectDialog : public Gtk::Dialog
{
public: 
    ConnectDialog();
    
    Glib::ustring get_server();
    int get_port();

protected:
    PP::OptionsBox m_optionsbox;
    Gtk::Entry m_server;
    Gtk::SpinButton m_port;
};

#endif // _COREINTERFACE_H_
