/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _MAINWINDOW_H_
#define _MAINWINDOW_H_


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/box.h>
#include <gtkmm/paned.h>
#include <gtkmm/statusbar.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/window.h>
#include <gtkmm/uimanager.h>
#include <gtkmm/label.h>

#include "ArenaView.h"
#include "MessageView.h"
#include "ScoreView.h"

class MainWindow:public Gtk::Window {
  public:
    MainWindow();
    ~MainWindow();

    void set_progress(double time, double timeout);
    void set_gamesequence(const int game, const int seq, const int games, const int seqs);

  protected:
    virtual void quit_rtb();
    virtual void new_tournament();
  
    virtual void open_logfile(const char* file);

    virtual void pause();
    virtual void statistics_clicked();
    virtual void options_clicked();
    virtual void end_clicked();

    virtual void start_test_tournament(const char *data);

    Gtk::VBox m_Box;
    Gtk::HPaned m_HPaned;
    Gtk::VPaned m_VPaned;
    Gtk::Statusbar m_StatusBar;
    Gtk::ProgressBar m_ProgressBar;
    Gtk::Label m_TurnInfo;

    Glib::ustring tournament_file;

    Glib::RefPtr < Gtk::UIManager > m_refUIManager;
    Glib::RefPtr < Gtk::ActionGroup > m_refActionGroup;

};

#endif //_MAINWINDOW_H_
