/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "MessageView.h"

#include <glib/gi18n.h>


MessageView::MessageView()
{
    set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
    add(m_TreeView);
    set_border_width(12);
    set_shadow_type(Gtk::SHADOW_IN);

    //Create list
    m_refTreeModel = Gtk::ListStore::create(m_Columns);
    m_TreeView.set_model(m_refTreeModel);
    m_TreeView.append_column(_("robot"), m_Columns.m_col_id);
    m_TreeView.append_column(_("points"), m_Columns.m_col_message);
    show_all();
}


MessageView::~MessageView()
{
    // TODO: put destructor code here
}

void
 MessageView::clear()
{
    m_refTreeModel->clear();
}

void MessageView::add_message(const Glib::ustring & name_of_messager, const Glib::ustring & message)
{
    //insert new row
    Gtk::TreeModel::Row row = *(m_refTreeModel->append());
    row[m_Columns.m_col_id] = name_of_messager;
    row[m_Columns.m_col_message] = message;

    //scroll to the new row (end of list)
    m_TreeView.scroll_to_row(m_refTreeModel->get_path(row));

}
