/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _MESSAGEVIEW_H_
#define _MESSAGEVIEW_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/scrolledwindow.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>

class MessageView:public Gtk::ScrolledWindow {
  public:
    MessageView();
    ~MessageView();

    void clear();
    void add_message(const Glib::ustring & name_of_messager, const Glib::ustring & message);

  protected:

    class ModelColumns:public Gtk::TreeModel::ColumnRecord {
      public:

	ModelColumns() {
	    add(m_col_id);
	    add(m_col_message);
	} Gtk::TreeModelColumn < Glib::ustring > m_col_id;
	Gtk::TreeModelColumn < Glib::ustring > m_col_message;
    };

    ModelColumns m_Columns;

    Gtk::TreeView m_TreeView;
    Glib::RefPtr < Gtk::ListStore > m_refTreeModel;
};


#endif				//_MESSAGEVIEW_H_
