/* 
 * RealTimeBattle Client
 * Copyright (C) 2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _NEWTOURNAMENT_H_
#define _NEWTOURNAMENT_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/scrolledwindow.h>
#include <gtkmm/table.h>
#include <gtkmm/separator.h>


#include <gtkmm/dialog.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>


#include <string>
using namespace std;

class NewTournament : public Gtk::Dialog
{
public:
    NewTournament();
    ~NewTournament();

    bool write_tournament_file();
    string get_tournament_file();

protected:

    class ModelColumns:public Gtk::TreeModel::ColumnRecord
    {
    public:
        ModelColumns(){
            add(name);
            add(file);
        }
        Gtk::TreeModelColumn < Glib::ustring > name;
        Gtk::TreeModelColumn < Glib::ustring > file;
    }m_Columns;

    void read_dir_to_list(Glib::ustring directory, Glib::RefPtr < Gtk::ListStore > &refTree, gchar * extension = ".robot");
    void read_tournament_file(string & filename);
    bool write_tournament_file(string & filename);

    string tempfile;
    
    Gtk::SpinButton m_gps;
    Gtk::SpinButton m_rps;
    Gtk::SpinButton m_nos;
    
    Gtk::SpinButton m_energy;
    Gtk::SpinButton m_max_energy;
    
    Gtk::TreeView m_selected_robots;
    Glib::RefPtr<Gtk::ListStore> m_ref_sr_model;
    Gtk::TreeView m_available_robots;
    Glib::RefPtr<Gtk::ListStore> m_ref_ar_model;
    
    Gtk::TreeView m_selected_arenas;
    Glib::RefPtr<Gtk::ListStore> m_ref_sa_model;
    Gtk::TreeView m_available_arenas;
    Glib::RefPtr<Gtk::ListStore> m_ref_aa_model;
    
    Gtk::TreeView m_env_list;
    Glib::RefPtr<Gtk::ListStore> m_ref_env_model;
     
    
    void load_tournament();
    void save_tournament();
    
    void add_robots();
    void remove_robots();
    void add_custom_robot();
     
    void add_arenas();
    void remove_arenas();
    void add_custom_arena();
    
    void add_robot_callback(const Gtk::TreeModel::iterator & iter);
    void add_arena_callback(const Gtk::TreeModel::iterator & iter);
};


#endif //_NEWTOURNAMENT_H_
