/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <math.h>
#include <iostream>
using namespace std;



#include "Robot.h"
#include "ArenaDrawingArea.h"
#include "MessageView.h"
#include "ScoreView.h"


#include "Arena.h"
extern Arena the_arena;
extern MessageView *the_messageview;
extern ScoreView *the_scoreview;


Robot::Robot(int id, long color, char *name):name(Glib::locale_to_utf8(name))
{
    this->color = color;
    this->id = id;
    strcpy(name2, name);
    alive = false;
    added = false;
    points = 0;	
}


Robot::~Robot()
{
    cout << "AHHRG" << endl;
}


void
 Robot::draw_robot(ArenaDrawingArea * the_view)
{
    this->the_view = the_view;
    if (alive == true) {
	double radius = 0.5 / the_arena.scale;
	double x = this->x / the_arena.scale;
	double y = this->y / the_arena.scale;

	double len = radius * 0.75;

	//Clear old Robot position and save new position
	the_view->draw_circle(drawpos_x, drawpos_y, radius, 0xffffff);
	drawpos_x = x;
	drawpos_y = y;

	//Draw Robot
	the_view->draw_circle(x, y, radius, color);
	the_view->draw_line(x, y, x + cos(direction) * radius * 0.8, y + sin(direction) * radius * 0.9, 0.025 / the_arena.scale);

	// Draw Cannon
	the_view->draw_line(x, y, x + cos(direction + canon) * len, y + sin(direction + canon) * len, 0.2 / the_arena.scale);

	// Draw radar lines     
	the_view->draw_line(x, y, x + cos(direction + radar + (M_PI / 4.0)) * len, y + sin(direction + radar + (M_PI / 4.0)) * len, 0.1 / the_arena.scale);
	the_view->draw_line(x, y, x + cos(direction + radar - (M_PI / 4.0)) * len, y + sin(direction + radar - (M_PI / 4.0)) * len, 0.1 / the_arena.scale);

    }
}

void Robot::set_position(double x, double y, double direction, double canon, double radar)
{
    this->x = x;
    this->y = y;
    this->direction = direction;
    this->canon = canon;
    this->radar = radar;

    alive = true;
}

void Robot::update_robot(double energy, int place)
{
    if (!added) {
    	the_scoreview->add_robot(id, name2, color);
        added = true;
    }
    
    //if (this->energy != energy || place != -1) {
	if (energy == 500.0) {
	    the_scoreview->update_robot(id, this->energy, place);
	}
	else {
	   this->energy = energy;
	   the_scoreview->update_robot(id, energy, place);
	}
   // }
}

void Robot::update_points(double points)
{
    this->points = this->points + points;
    
}

void Robot::update_message_view()
{
    char tmp[255];
    sprintf(tmp,"%i", this->points);
    //tmp << points;
    message(tmp);
}

void Robot::message(char *message)
{
    the_messageview->add_message(name, message);
}

void Robot::kill()
{
    alive = false;
    added = false;
    the_view->draw_circle(drawpos_x, drawpos_y, 0.5 / the_arena.scale, 0xffffff);
  //  the_messageview->add_message(name, "Puff... Und weg bin ich!!!");
}

