/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _ROBOT_H_
#define _ROBOT_H_

#include <glibmm/ustring.h>


class ArenaDrawingArea;


class Robot {
  public:
    Robot(int id, long color, char *name);
    ~Robot();

    void set_position(double x, double y, double direction, double canon, double radar);
    void update_robot(double energy, int place = -1);
    void update_points(double points);
    void Robot::update_message_view();
    void draw_robot(ArenaDrawingArea * the_view);
    void message(char *message);
    void kill(); 
   
  protected:

    int id, points;
    ArenaDrawingArea *the_view;
    bool alive;
    bool added;
    long color;
     Glib::ustring name;
    char name2[255];
    double x, y;
    double energy;
    double direction, canon, radar;
    double drawpos_x, drawpos_y;
};


#endif				//_ROBOT_H_
