/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _SCOREVIEW_H_
#define _SCOREVIEW_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/scrolledwindow.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>


class ScoreView:public Gtk::ScrolledWindow {
  public:
    ScoreView();
    ~ScoreView();

    void clear();

    void add_robot(int id, char *name, long color);
    void update_robot(int id, double energy, int place);

  protected:

    class ModelColumns:public Gtk::TreeModel::ColumnRecord {
      public:

	ModelColumns() {
	    add(m_col_id);
	    add(m_col_color);
	    add(m_col_name);
	    add(m_col_energy);
	    add(m_col_place);
	} Gtk::TreeModelColumn < int >m_col_id;
	Gtk::TreeModelColumn < Glib::RefPtr < Gdk::Pixbuf > >m_col_color;
	Gtk::TreeModelColumn < Glib::ustring > m_col_name;
	Gtk::TreeModelColumn < int >m_col_energy;
	Gtk::TreeModelColumn < Glib::ustring > m_col_place;
    };

    ModelColumns m_Columns;

    Gtk::TreeView m_TreeView;
    Glib::RefPtr < Gtk::ListStore > m_refTreeModel;

};


#endif				//_SCOREVIEW_H_
