/* 
 * RealTimeBattle Client
 * Copyright (C) 2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _STUFF_H_
#define _STUFF_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtkmm/box.h>
#include <gtkmm/label.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/sizegroup.h>

namespace PP{

class OptionsBox : public Gtk::VBox
{
public:
    OptionsBox(Glib::ustring title);

    void add_option(Glib::ustring title, Gtk::Widget &widget);
    void add_option(Gtk::Widget &widget);

    void set_size_group1(Glib::RefPtr<Gtk::SizeGroup> group);
    void set_size_group2(Glib::RefPtr<Gtk::SizeGroup> group);
    Glib::RefPtr<Gtk::SizeGroup> get_size_group1();
    Glib::RefPtr<Gtk::SizeGroup> get_size_group2();

protected:
    OptionsBox();    

    Gtk::Label m_title;
    Gtk::VBox m_content_box;

    Glib::RefPtr<Gtk::SizeGroup> m_group1;
    Glib::RefPtr<Gtk::SizeGroup> m_group2;

    Gtk::Label m_separator_label;

    void add_content_box();
};

class RadioOptionsBox : public OptionsBox
{
public:
    RadioOptionsBox(Gtk::RadioButtonGroup &group, Glib::ustring title);

protected:
    Gtk::RadioButton m_radio;
    void radio_toggled();
};

} // namespace PP

#endif //_STUFF_H_
