/* 
 * RealTimeBattle Client
 * Copyright (C) 2003-2005 Volker Stroebel <volker@planetpenguin.de>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "math.h"

#include "Vector2D.h"


Vector2D::Vector2D()
{
    this->x = 0.0;
    this->y = 0.0;
}

Vector2D::Vector2D(double x, double y)
{
    this->x = x;
    this->y = y;
}

Vector2D::~Vector2D()
{
    // TODO: put destructor code here
}

Vector2D & Vector2D::operator/=(const double denom)
{
    x /= denom;
    y /= denom;
    return (*this);
}


Vector2D & Vector2D::normalize()
{
    *this /= this->length();
    return (*this);
}

Vector2D & Vector2D::rotate(const double angle)
{
    double tempx, tempy;
    tempx = cos(angle) * x - sin(angle) * y;
    tempy = sin(angle) * x + cos(angle) * y;

    x = tempx;
    y = tempy;

    return (*this);
}

double Vector2D::length()
{
    return (sqrt(x * x + y * y));
}

//Friends

istream & operator>>(istream & is, Vector2D & vec)
{
    is >> vec.x >> vec.y;
    return (is);
}
